#include <iostream>
#include <string>

void f() {}

void g(const std::string& identity) { /* ... */ }

int main(int argc, char** argv) {
	std::cout << "typeid(decltype(::f)): " << typeid (decltype(::f)).name() << std::endl; // Type of 'f'
	std::cout << "typeid(decltype(::f())): " << typeid (decltype(::f())).name() << std::endl; // Returned type of 'f', i.e., 'void'

	// std::cout << "typeid(decltype(::g())): " << typeid(decltype(::g())).name() << std::endl; // Compilation error -> problem simply comes from an absence of argument...
	std::cout << "typeid(decltype(::g(std::string&))): " << typeid (decltype(::g("Fictitious string!"))).name() << std::endl; // OK!
	std::cout << "typeid(decltype(::g(std::string&))): " << typeid (decltype(::g(std::declval<const std::string&>()))).name() << std::endl; // Even better!

	return 0;
}

